﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;


namespace boca_sample
{
    public partial class FrmComm : Form
    {
        private FrmBoca m_parent;

        public FrmComm(FrmBoca frm1)
        {
            InitializeComponent();
            m_parent = frm1;
        }

        private void CmdOK_Click(object sender, EventArgs e)
        {
            string rate;
            string fgl_command = "";
            string text_command = "";
            string baud = TxtBaud.Text;
            string parity = TxtParity.Text;
            string bits = TxtBits.Text;
            bool status = false;
            //@mdh check this DialogResult result;

            rate = TxtBaud.Text + "," + TxtParity.Text + "," + TxtBits.Text;
            this.Close();                               //close serial port communication form FrmComm
            fgl_command = "<VS1><br" + rate + ">";           //build PCL/FGL baud rate command string   //1.4.1.0
            text_command = "Sent Baud Rate command <VS1><br" + rate + ">";   //user string              //1.4.1.0

                //To change the communcation parameters the serial port needs to be closed and reopened if in use
                //We can arrive here if find_baud was unable to automatically establish the baud rate.  
                //For PCL printers especially. The user has entered baud, parity, bits 
                //so just open the port as described. if open close it first.               //1.5.1.0
                if (m_parent.Current_Port == "SER")                                         //1.7.1.0 
                {
                    if (Serial_Port.PortAccess.Boca_Serial != null)                         //1.7.1.0
                    {
                        //6.4.0.0 if (Serial_Port.PortAccess.Boca_Serial.IsOpen)
                        //6.4.0.0 {
                            //6.4.0.0 m_parent.Transmit(fgl_command);                     //send rate command to printer
                            //6.4.0.0 m_parent.Display_Text(text_command);                //display command for user
                            //6.4.0.0 Serial_Port.PortAccess.Boca_Serial.Close();         //close port
                        //6.4.0.0 }
                        //6.4.0.0
                        try
                        {
                            //if the port is already open, close it so it can be open with the current settings
                            if (Serial_Port.PortAccess.Boca_Serial.IsOpen)
                            {
                                m_parent.Transmit(fgl_command);                     //send rate command to printer
                                m_parent.Display_Text(text_command);                //display command for user
                                Serial_Port.PortAccess.Boca_Serial.Close();         //close port
                            }
                        }
                        catch (Exception ex)                                         //6.4.0.0
                        {
                            MessageBox.Show("FRMCOMM Close port handle invalid while opening Serial Port " + Serial_Port.PortAccess.Boca_Serial.PortName);
                            MessageBox.Show("Exception Message = " + ex.Message);    //6.4.0.0
                        }
                        //6.4.0.0

                    }
                    
                    Thread.Sleep(500);                                      //delay 1/2 second before re-opening

                    //Re-open serial port using the new values
                    status = Serial_Port.PortAccess.Open_Serial(m_parent.Current_Port_Name, baud, parity, bits);
                    //if (status)
                    //{
                        //m_parent.printer_ready();
                        //m_parent.Display_Text("Successfully opened " + m_parent.Current_Port_Name + " with rate " + rate);
                    //}
                    //else
                    //{
                        //m_parent.printer_port_closed();
                        //m_parent.Display_Text("Failed to open serial port " + m_parent.Current_Port_Name);
                    //}

                }
                else                                        //a another port/driver is already open so use it
                {
                    //1.3.2.0  changing baud rate
                    m_parent.Transmit(fgl_command);         //send rate command to printer
                    m_parent.Display_Text(text_command);    //display command for user
                    m_parent.reset();                       //close whatever port/driver is open
                    m_parent.Refresh();                     //refresh screen so user knows to Open a port/driver again
                    //MessageBox.Show("port = " + m_parent.Current_Port);
                }
         }

        private void LstBaud_SelectedIndexChanged(object sender, EventArgs e)
        {
            TxtBaud.Text = LstBaud.Text;
        }

        private void LstParity_SelectedIndexChanged(object sender, EventArgs e)
        {
            TxtParity.Text = LstParity.Text;
        }

        private void LstBits_SelectedIndexChanged(object sender, EventArgs e)
        {
            TxtBits.Text = LstBits.Text;
        }

        private void FrmComm_Load(object sender, EventArgs e)
        {
            //TxtBaud.Text = m_parent.
        }
    }
}
