﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace boca_sample
{
    public partial class FrmGraphics : Form
    {
        public string file_type;
        private FrmBoca m_parent;
        
        public FrmGraphics(FrmBoca frm1)
        {
            InitializeComponent();
            m_parent = frm1;
        }

        private void FrmGraphics_Load(object sender, EventArgs e)
        {
            file_type = "pcx";
            m_parent.Logo_ID_Number = "";
            ID_Num.Text = "";
            OptAuto.Checked = true;
        }

        private void OptPcx_CheckedChanged(object sender, EventArgs e)
        {
            file_type = "pcx";
        }

        private void OptJpg_CheckedChanged(object sender, EventArgs e)
        {
            file_type = "jpg";
        }

        private void OptBmp_CheckedChanged(object sender, EventArgs e)
        {
            file_type = "bmp";
        }

        //use zero for ticket count to signal download monochrome image to memory
        private void CmdDown_Click(object sender, EventArgs e)
        {
            if (OptManual.Checked && Convert.ToInt32(ID_Num.Text) > 0 && Convert.ToInt32(ID_Num.Text) < 100)
                m_parent.Logo_ID_Number = ID_Num.Text;
            else
                m_parent.Logo_ID_Number = "";

            m_parent.select_file(file_type, 0);
        }
        //print one copy of monochrome image
        private void CmdPrint_Click(object sender, EventArgs e)
        {
            m_parent.select_file(file_type, 1);
        }

        private void CmdClearDown_Click(object sender, EventArgs e)
        {
            m_parent.clear_download_space();
        }

        private void OptAuto_CheckedChanged(object sender, EventArgs e)
        {
            if (OptAuto.Checked)
            {
                ID_Num.Visible = false;
                m_parent.Logo_ID_Number = "";
            }
        }

        private void OptManual_CheckedChanged(object sender, EventArgs e)
        {
            if (OptManual.Checked)
            {
                ID_Num.Visible = true;
                ID_Num.Text = "";
                m_parent.Logo_ID_Number = "";
            }
        }

        private void ID_Num_TextChanged(object sender, EventArgs e)
        {
            bool success;
            char c;
            string s, incoming = ID_Num.Text;
            int x = incoming.Length;

            if (x > 2)
            {
                m_parent.Display_Text("Logo ID field max length of 2 characters has been exceeded. Valid Range 1 to 99.");
                MessageBox.Show("Logo ID field max length of 2 characters has been exceeded. Valid Range 1 to 99.");
                ID_Num.Text = "";
            }
            else
            {
                if (x > 0)
                {
                    s = incoming.Substring(x - 1, 1);
                    c = s[0];
                    success = validate_digit(c);
                    if (success == false)
                    {
                        m_parent.Display_Text("Invalid digit entered " + c + ".  Each character must be 0 to 9. Valid Range 1 to 99.");
                        MessageBox.Show("Invalid digit entered " + c + ".  Each character must be 0 to 9. Valid Range 1 to 99.");
                        ID_Num.Text = incoming.Substring(0, x - 1);
                    }
                }
            }
        }

        //verify decimal character is 0 to 9
        private bool validate_digit(char character)
        {
            bool status;

            if ((character >= 48) && (character <= 57)) 
                status = true;
            else
                status = false;

            return (status);
        }


    }
}
