﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace boca_sample
{
    public partial class FrmNum : Form
    {
        private FrmBoca m_parent;

        public FrmNum(FrmBoca frm1)
        {
            InitializeComponent();
            m_parent = frm1;
        }

        private void FrmNum_Load(object sender, EventArgs e)
        {
            switch (FrmBoca.choice_index)
            {
                case 3:
                    //Send Ascii value to printer
                    Text = "Send ASCII Value";
                    LblNum1.Text = "Decimal Ascii Value";
                    LblNum1.Visible = true;
                    LblNum2.Visible = false;
                    LblNum3.Visible = false;
                    TxtNum1.Visible = true;
                    TxtNum2.Visible = false;
                    TxtNum3.Visible = false;
                    break;

                case 10:
                    //Enable expansion flash using serial number and license number
                    Text = "Enable Expansion Flash";
                    LblNum2.Text = "License Number";
                    LblNum1.Visible = true;
                    LblNum2.Visible = true;
                    LblNum3.Visible = false;
                    TxtNum1.Visible = true;
                    TxtNum2.Visible = true;
                    TxtNum3.Visible = false;
                    break;
                case 13:
                    //Enable expansion flash using serial number and license number
                    Text = "USB R/W Timeout - milliseconds";
                    LblNum1.Text = "Write Timeout";
                    LblNum2.Text = "Read Timeout";
                    LblNum1.Visible = true;
                    LblNum2.Visible = true;
                    LblNum3.Visible = false;
                    TxtNum1.Text = FrmBoca.write_timeout.ToString();        //initialize field with current write timeout
                    TxtNum2.Text = FrmBoca.read_timeout.ToString();         //initialize field with current read timeout
                    TxtNum1.Visible = true;
                    TxtNum2.Visible = true;
                    TxtNum3.Visible = false;
                    break;
                case 14:
                    Text = "Upgrade to 40's";
                    LblNum2.Text = "License Number";
                    LblNum1.Visible = true;
                    LblNum2.Visible = true;
                    LblNum3.Visible = false;
                    TxtNum1.Visible = true;
                    TxtNum2.Visible = true;
                    TxtNum3.Visible = false;
                    break;
                case 15:
                    Text = "Downgrade to 20's";
                    LblNum2.Text = "License Number";
                    LblNum1.Visible = true;
                    LblNum2.Visible = true;
                    LblNum3.Visible = false;
                    TxtNum1.Visible = true;
                    TxtNum2.Visible = true;
                    TxtNum3.Visible = false;
                    break;
                case 18:
                    Text = "Establish New Default State";
                    //establish the current state as the new factory default state using current SN
                    LblNum1.Visible = true;
                    LblNum2.Visible = false;
                    LblNum3.Visible = false;
                    TxtNum1.Visible = true;
                    TxtNum2.Visible = false;
                    TxtNum3.Visible = false;
                    break;
                case 19:
                    Text = "Change Printer Serial Number";
                    //change the factory given serial number to a new one and establish the 
                    //current state as the new factory default state
                    LblNum1.Visible = true;
                    LblNum2.Visible = true;
                    LblNum3.Visible = true;
                    TxtNum1.Visible = true;
                    TxtNum2.Visible = true;
                    TxtNum3.Visible = true;
                    break;
                case 25:
                    Text = "Pick HID Printer by Serial Number";
                    LblNum1.Text = "Enter Serial Number";
                    LblNum1.Visible = true;
                    LblNum2.Visible = false;
                    LblNum3.Visible = false;
                    TxtNum1.Visible = true;
                    TxtNum2.Visible = false;
                    TxtNum3.Visible = false;
                    break;
            }
            TxtNum1.Focus();

        }

        private void CmdOk_Click(object sender, EventArgs e)
        {
            int num1;
            string s1 = "";
            string s2 = "";
            byte[] b1 = new byte[1];
            if (TxtNum1.TextLength > 0)
            {
                num1 = Convert.ToInt32(TxtNum1.Text);
                switch (FrmBoca.choice_index)
                {
                    case 3:
                        //Send Ascii value to printer
                        b1[0] = Convert.ToByte(TxtNum1.Text);
                        m_parent.Transmitb(b1);
                        break;

                    case 13:
                        //set USB/HID read and write timeout periods
                        if (TxtNum1.Text != "")
                            FrmBoca.write_timeout = Convert.ToInt32(TxtNum1.Text);
                        if (TxtNum2.Text != "")
                            FrmBoca.read_timeout = Convert.ToInt32(TxtNum2.Text);
                        this.Close();
                        break;

                    case 25:

                        //Pick one of multiple USB.HID printers
                        int i;
                        int sn = Convert.ToInt32(TxtNum1.Text);
                        
                        //We got here from PICK button on GUI, so stop whichever read thread is
                        //associated with currently selected printer
                        m_parent.USBHID_Dissconnect();
                        
                        //now establish new connection if HID printer found by serial number
                        //pass the sn to find so that specific USB/HID printer will be selected once found
                        i = USBHID.HIDDevice.Find_HIDs(sn);
                        if (i == 1)
                        {
                            s1 = "HID Printer with serial number " + TxtNum1.Text + " is currently selected.";
                            s2 = TxtNum1.Text;
                            m_parent.printer_ready();
                        }
                        else
                        {
                            m_parent.port_shutdown();                        //shut down port read thread
                            s1 = "HID Printer with serial number " + TxtNum1.Text + " was not found.";
                            s2 = "";
                            m_parent.printer_not_found();
                        }
                        m_parent.Display_Text(s1);
                        m_parent.Display_SN(s2);
                        this.Close();

                        break;
                }
            }
            else
            {
                s1 = "No serial number entered, aborting current function.";
                m_parent.Display_Text(s1);
            }
        }

        private void CmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}
